Hardware Locality (hwloc): Interoperability with the CUDA Driver API

Hardware Locality (hwloc) 2.14.0rc1

Functions
Interoperability with the CUDA Driver API

## Functions
int | hwloc_cuda_get_device_pci_ids (hwloc_topology_t topology, CUdevice cudevice, int *domain, int *bus, int *dev)
int | hwloc_cuda_get_device_cpuset (hwloc_topology_t topology, CUdevice cudevice, hwloc_cpuset_t set)
hwloc_obj_t | hwloc_cuda_get_device_pcidev (hwloc_topology_t topology, CUdevice cudevice)
hwloc_obj_t | hwloc_cuda_get_device_osdev (hwloc_topology_t topology, CUdevice cudevice)
hwloc_obj_t | hwloc_cuda_get_device_osdev_by_index (hwloc_topology_t topology, unsigned idx)

## Detailed Description

This interface offers ways to retrieve topology information about CUDA devices when using the CUDA Driver API.

## Function Documentation

## ◆ hwloc_cuda_get_device_cpuset()

int hwloc_cuda_get_device_cpuset | ( | hwloc_topology_t | topology,
|  | CUdevice | cudevice,
|  | hwloc_cpuset_t | set )
| inline

Get the CPU set of processors that are physically close to device `cudevice`.

Store in `set` the CPU-set describing the locality of the CUDA device `cudevice`.

Topology `topology` and device `cudevice` must match the local machine. I/O devices detection and the CUDA component are not needed in the topology.

The function only returns the locality of the device. If more information about the device is needed, OS objects should be used instead, see hwloc_cuda_get_device_osdev() and hwloc_cuda_get_device_osdev_by_index().

This function is currently only implemented in a meaningful way for Linux; other systems will simply get the cpuset of the entire topology.

Returns
  0 on success.
  -1 on error, for instance if device information could not be found.

## ◆ hwloc_cuda_get_device_osdev()

hwloc_obj_t hwloc_cuda_get_device_osdev | ( | hwloc_topology_t | topology,
|  | CUdevice | cudevice )
| inline

Get the hwloc OS device object corresponding to CUDA device `cudevice`.

Returns
  The hwloc OS device object that describes the given CUDA device `cudevice`.
  `NULL` if none could be found.

Topology `topology` and device `cudevice` must match the local machine. I/O devices detection and the CUDA component must be enabled in the topology. If not, the locality of the object may still be found using hwloc_cuda_get_device_cpuset().

Note
  This function cannot work if PCI devices are filtered out.
  The corresponding hwloc PCI device may be found by looking at the result parent pointer (unless PCI devices are filtered out).

## ◆ hwloc_cuda_get_device_osdev_by_index()

hwloc_obj_t hwloc_cuda_get_device_osdev_by_index | ( | hwloc_topology_t | topology,
|  | unsigned | idx )
| inline

Get the hwloc OS device object corresponding to the CUDA device whose index is `idx`.

Returns
  The hwloc OS device object describing the CUDA device whose index is `idx`.
  `NULL` if none could be found.

The topology `topology` does not necessarily have to match the current machine. For instance the topology may be an XML import of a remote host. I/O devices detection and the CUDA component must be enabled in the topology.

Note
  The corresponding PCI device object can be obtained by looking at the OS device parent object (unless PCI devices are filtered out).
  This function is identical to hwloc_cudart_get_device_osdev_by_index().

## ◆ hwloc_cuda_get_device_pci_ids()

int hwloc_cuda_get_device_pci_ids | ( | hwloc_topology_t | topology,
|  | CUdevice | cudevice,
|  | int * | domain,
|  | int * | bus,
|  | int * | dev )
| inline

Return the domain, bus and device IDs of the CUDA device `cudevice`.

Device `cudevice` must match the local machine.

Returns
  0 on success.
  -1 on error, for instance if device information could not be found.

## ◆ hwloc_cuda_get_device_pcidev()

hwloc_obj_t hwloc_cuda_get_device_pcidev | ( | hwloc_topology_t | topology,
|  | CUdevice | cudevice )
| inline

Get the hwloc PCI device object corresponding to the CUDA device `cudevice`.

Returns
  The hwloc PCI device object describing the CUDA device `cudevice`.
  `NULL` if none could be found.

Topology `topology` and device `cudevice` must match the local machine. I/O devices detection must be enabled in topology `topology`. The CUDA component is not needed in the topology.